import { HttpHeaders, HttpClient } from '@angular/common/http';
import { Injectable, ɵɵdefineInjectable, ɵɵinject, Component, Pipe, NgModule } from '@angular/core';
import { Location, CommonModule } from '@angular/common';
import { ActivatedRoute, RouterModule } from '@angular/router';
import { AsapSharedModule } from 'asap-shared';
import { AsapBaseCRUD, AsapService, Global } from 'asap-crud';
import { DomSanitizer } from '@angular/platform-browser';

/**
 * @fileoverview added by tsickle
 * Generated from: lib/asap-news.service.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class AsapNewsService {
    /**
     * @param {?} http
     */
    constructor(http) {
        this.http = http;
        this.host = localStorage.getItem('apiURL');
    }
    /**
     * @param {?} id
     * @return {?}
     */
    find(id) {
        return this.http.get(this.host + '/api/v2/client/news/' + id, this.getHeaders());
    }
    /**
     * @param {?} id
     * @return {?}
     */
    section(id) {
        return this.http.get(this.host + '/api/v2/client/news-section/' + id + '/news', this.getHeaders());
    }
    /**
     * @return {?}
     */
    getHeaders() {
        /** @type {?} */
        let token = '';
        if (localStorage.getItem('token')) {
            token = localStorage.getItem('token');
        }
        /** @type {?} */
        const headerOptions = {
            'Authorization': token,
            'Accept': 'application/json'
        };
        return { headers: new HttpHeaders(headerOptions) };
    }
}
AsapNewsService.decorators = [
    { type: Injectable, args: [{
                providedIn: 'root'
            },] }
];
/** @nocollapse */
AsapNewsService.ctorParameters = () => [
    { type: HttpClient }
];
/** @nocollapse */ AsapNewsService.ngInjectableDef = ɵɵdefineInjectable({ factory: function AsapNewsService_Factory() { return new AsapNewsService(ɵɵinject(HttpClient)); }, token: AsapNewsService, providedIn: "root" });
if (false) {
    /** @type {?} */
    AsapNewsService.prototype.host;
    /** @type {?} */
    AsapNewsService.prototype.http;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/asap-news.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class AsapNewsComponent {
}
AsapNewsComponent.decorators = [
    { type: Component, args: [{
                selector: 'asap-news',
                template: `<router-outlet></router-outlet>`
            }] }
];

/**
 * @fileoverview added by tsickle
 * Generated from: lib/all-news/all-news.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class AllNewsComponent extends AsapBaseCRUD {
    /**
     * @param {?} global
     * @param {?} activatedRoute
     * @param {?} service
     */
    constructor(global, activatedRoute, service) {
        super(global, service);
        this.global = global;
        this.activatedRoute = activatedRoute;
        this.service = service;
        this.service.basePath = 'api/v2/client';
        this.service.entityName = 'news/search';
        this.cumulativeData = true;
        /** @type {?} */
        let params = this.global.decodeQueryString();
        this.session = params.session;
        this.title = params.session_name;
        this.afterCreate();
    }
    /**
     * @return {?}
     */
    ngOnInit() {
    }
    /**
     * @param {?=} page
     * @return {?}
     */
    listAll(page = 1) {
        /** @type {?} */
        let data = Object.assign({ session: this.session }, this.filter);
        this.service.createResource(data).subscribe((/**
         * @param {?} response
         * @return {?}
         */
        (response) => {
            this.list = response;
        }));
    }
    /**
     * @param {?} filter
     * @return {?}
     */
    doFilter(filter) {
        this.filter = filter;
        this.listAll();
    }
}
AllNewsComponent.decorators = [
    { type: Component, args: [{
                selector: 'app-all-news',
                template: "<div class=\"wrapper\">\n  <!-- <app-navbar></app-navbar>\n  <app-navbar-mobile></app-navbar-mobile>\n  <app-sidemenu></app-sidemenu> -->\n  <div class=\"content\">\n    <div class=\"compress py-5\">\n      <!-- <h3>{{title}}</h3> -->\n      <asap-generic-all (filter)=\"doFilter($event)\" [data]=\"list\" *ngIf=\"list\"></asap-generic-all>\n\n      <div class=\"text-center\" *ngIf=\"meta?.current_page != meta?.last_page\">\n        <button *ngIf=\"!loading\" class=\"btn btn-primary\" (click)=\"listAll(meta?.current_page+1)\">Carregar mais</button>\n        <button *ngIf=\"loading\" class=\"btn btn-primary\" disabled>\n          <i class=\"fa fa-spin fa-circle-o-notch\"></i>\n        </button>\n      </div>\n    </div>\n  </div>\n</div>\n",
                providers: [AsapService]
            }] }
];
/** @nocollapse */
AllNewsComponent.ctorParameters = () => [
    { type: Global },
    { type: ActivatedRoute },
    { type: AsapService }
];
if (false) {
    /** @type {?} */
    AllNewsComponent.prototype.session;
    /** @type {?} */
    AllNewsComponent.prototype.title;
    /** @type {?} */
    AllNewsComponent.prototype.filter;
    /** @type {?} */
    AllNewsComponent.prototype.global;
    /** @type {?} */
    AllNewsComponent.prototype.activatedRoute;
    /** @type {?} */
    AllNewsComponent.prototype.service;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/detail/asap-news-detail.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class AsapNewsDetailComponent {
    /**
     * @param {?} newsService
     * @param {?} activatedRoute
     * @param {?} location
     */
    constructor(newsService, activatedRoute, location) {
        this.newsService = newsService;
        this.activatedRoute = activatedRoute;
        this.location = location;
        this.activatedRoute.params.subscribe((/**
         * @param {?} param
         * @return {?}
         */
        (param) => {
            this.id = +param.id;
        }));
    }
    /**
     * @return {?}
     */
    ngOnInit() {
        /** @type {?} */
        const lu = localStorage.getItem('loggedUser');
        if (lu) {
            this.loggedUser = JSON.parse(lu).data;
        }
        this.getData();
    }
    /**
     * @return {?}
     */
    getData() {
        this.loading = true;
        this.newsService.find(this.id)
            .subscribe((/**
         * @param {?} res
         * @return {?}
         */
        res => {
            if (this.loggedUser || res.data.visibility === 'guest') {
                this.item = res.data;
            }
            else {
                this.notFound = true;
            }
            this.loading = false;
        }));
    }
}
AsapNewsDetailComponent.decorators = [
    { type: Component, args: [{
                selector: 'asap-news-detail',
                template: "<p *ngIf=\"loading\">Carregando...</p>\n<div style=\"margin-top: 20px\" class=\"col-sm-12 text-right\">\n  <a (click)=\"location.back()\">\n    <i class=\"bi bi-x-circle\" style=\"font-size: 30px\"></i>\n  </a>\n</div>\n<div class=\"row\" *ngIf=\"!loading\">\n  <div class=\"col-sm-8 mx-auto\">\n    <div class=\"intro-post\">\n      <h1>{{ item.title }}</h1>\n      <h4 class=\"mt-2\">{{ item.resume }}</h4>\n      <span class=\"date-post\"\n        ><i class=\"fa fa-clock\"></i> {{ item.created_at | date : \"dd/MM/y\" }} \u00E0s\n        {{ item.created_at | date : \"hh:mm\" }}</span\n      >\n    </div>\n\n    <img [src]=\"item.image\" class=\"cover-post\" alt=\"\" />\n\n    <div>\n      <div\n        class=\"asap-news-detail-text\"\n        [innerHTML]=\"item.text | safe : 'html'\"\n      ></div>\n    </div>\n\n    <div class=\"row\" *ngIf=\"item.author\">\n      <div class=\"col-sm-12\">\n        <div class=\"divider-line\"></div>\n        <figure>\n          <img [src]=\"item.author_photo\" class=\"user-created\" />\n        </figure>\n        <div class=\"user-created-info\">\n          <h2 class=\"written-by\">\n            Escrito por <strong>{{ item.author }}</strong>\n          </h2>\n          <span class=\"autor-description\">{{ item.author_about }}</span>\n        </div>\n      </div>\n    </div>\n\n    <div\n      *ngIf=\"item.attachments && item.attachments.length\"\n      class=\"download-area\"\n    >\n      <p class=\"title\">Anexos:</p>\n      <p class=\"mb-3\">Clique no(s) arquivo(s) para baixar.</p>\n      <div class=\"row\">\n        <div *ngFor=\"let att of item.attachments\" class=\"col-sm-4\">\n          <a target=\"_blank\" [href]=\"att.path\">\n            <i aria-hidden=\"true\" class=\"fa fa-file-pdf-o\"></i>\n            <span class=\"ml-2\">{{ att.name }}</span>\n          </a>\n        </div>\n      </div>\n    </div>\n  </div>\n</div>\n\n<p *ngIf=\"notFound\">Not\u00EDcia n\u00E3o dispon\u00EDvel</p>\n",
                styles: [".intro-post{display:flex;flex-direction:column;align-items:center;justify-content:space-around;min-height:100px;margin-bottom:30px;padding-top:30px;height:auto;text-align:center}.download-area{background:#f4f4f4;padding:10px;border-radius:4px;margin:20px 0}.download-area p.title{font-weight:500}.download-area a{display:block;min-width:100%;max-width:15ch;overflow:hidden;text-overflow:ellipsis;white-space:nowrap;color:#fff;background:var(--main-color);margin-bottom:10px;padding:5px 10px;font-size:13px;border-radius:4px}.download-area a:hover{opacity:.7}.date-post{padding-top:20px;text-transform:uppercase;color:#888;font-size:15px;font-weight:700}.cover-post{width:100%;height:auto;border-radius:16px;-o-object-fit:cover;object-fit:cover;margin-bottom:30px}.divider-line{width:100%;height:1px;margin-bottom:48px;margin-top:48px;background-color:#e1e1e1}figure{margin:0 0 1rem}figure .user-created{float:left;width:160px;height:160px;margin-right:20px;-o-object-fit:cover;object-fit:cover;border-radius:50%;overflow:hidden;padding:4px;border:1px solid #e1e1e1;display:block}.user-created-info{display:flex;align-items:flex-start;justify-content:center;flex-direction:column;height:160px;width:calc(100% - 180px);margin-bottom:50px}.user-created-info .written-by{padding-bottom:10px;font-weight:300}.user-created-info .autor-description{line-height:22px}@media (max-width:575.98px){figure{margin:0}figure .user-created{float:none;width:100px;height:100px;margin:0 auto 40px;-o-object-fit:cover;object-fit:cover;border-radius:50%;overflow:hidden}.user-created-info{display:flex;align-items:center;justify-content:center;flex-direction:column;height:auto;width:100%;margin-bottom:50px;text-align:center}.user-created-info .written-by{padding-bottom:10px;font-weight:300;font-size:18px}.user-created-info .autor-description{line-height:22px}}"]
            }] }
];
/** @nocollapse */
AsapNewsDetailComponent.ctorParameters = () => [
    { type: AsapNewsService },
    { type: ActivatedRoute },
    { type: Location }
];
if (false) {
    /** @type {?} */
    AsapNewsDetailComponent.prototype.id;
    /** @type {?} */
    AsapNewsDetailComponent.prototype.loading;
    /** @type {?} */
    AsapNewsDetailComponent.prototype.item;
    /** @type {?} */
    AsapNewsDetailComponent.prototype.loggedUser;
    /** @type {?} */
    AsapNewsDetailComponent.prototype.notFound;
    /** @type {?} */
    AsapNewsDetailComponent.prototype.newsService;
    /** @type {?} */
    AsapNewsDetailComponent.prototype.activatedRoute;
    /** @type {?} */
    AsapNewsDetailComponent.prototype.location;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/safe.pipe.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class SafePipe {
    /**
     * @param {?} sanitizer
     */
    constructor(sanitizer) {
        this.sanitizer = sanitizer;
    }
    /**
     * @param {?} url
     * @param {?=} type
     * @return {?}
     */
    transform(url, type) {
        switch (type) {
            case 'html': return this.sanitizer.bypassSecurityTrustHtml(url);
            case 'style': return this.sanitizer.bypassSecurityTrustStyle(url);
            case 'script': return this.sanitizer.bypassSecurityTrustScript(url);
            case 'url': return this.sanitizer.bypassSecurityTrustUrl(url);
            case 'resourceUrl': return this.sanitizer.bypassSecurityTrustResourceUrl(url);
            default: return this.sanitizer.bypassSecurityTrustResourceUrl(url);
        }
    }
}
SafePipe.decorators = [
    { type: Pipe, args: [{ name: 'safe' },] }
];
/** @nocollapse */
SafePipe.ctorParameters = () => [
    { type: DomSanitizer }
];
if (false) {
    /**
     * @type {?}
     * @private
     */
    SafePipe.prototype.sanitizer;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/section/asap-news-section.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class AsapNewsSectionComponent {
    /**
     * @param {?} newsService
     * @param {?} activatedRoute
     */
    constructor(newsService, activatedRoute) {
        this.newsService = newsService;
        this.activatedRoute = activatedRoute;
        this.activatedRoute.params.subscribe((/**
         * @param {?} param
         * @return {?}
         */
        (param) => {
            this.id = +param.id;
        }));
    }
    /**
     * @return {?}
     */
    ngOnInit() {
        this.getData();
    }
    /**
     * @return {?}
     */
    getData() {
        this.loading = true;
        this.newsService.section(this.id)
            .subscribe((/**
         * @param {?} res
         * @return {?}
         */
        res => {
            this.data = res.data;
            this.loading = false;
        }));
    }
}
AsapNewsSectionComponent.decorators = [
    { type: Component, args: [{
                selector: 'asap-news-section',
                template: `<pre>{{ data | json }}</pre>`
            }] }
];
/** @nocollapse */
AsapNewsSectionComponent.ctorParameters = () => [
    { type: AsapNewsService },
    { type: ActivatedRoute }
];
if (false) {
    /** @type {?} */
    AsapNewsSectionComponent.prototype.id;
    /** @type {?} */
    AsapNewsSectionComponent.prototype.loading;
    /** @type {?} */
    AsapNewsSectionComponent.prototype.data;
    /** @type {?} */
    AsapNewsSectionComponent.prototype.newsService;
    /** @type {?} */
    AsapNewsSectionComponent.prototype.activatedRoute;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/asap-news.module.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
const components = [
    AllNewsComponent,
    AsapNewsComponent,
    AsapNewsDetailComponent,
    AsapNewsSectionComponent
];
class AsapNewsModule {
}
AsapNewsModule.decorators = [
    { type: NgModule, args: [{
                imports: [
                    CommonModule,
                    RouterModule,
                    AsapSharedModule
                ],
                declarations: [
                    ...components,
                    SafePipe
                ],
                exports: [
                    ...components
                ]
            },] }
];

/**
 * @fileoverview added by tsickle
 * Generated from: lib/asap-news.routing.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
const AsapNewsRouting = [
    {
        path: ':id',
        component: AsapNewsDetailComponent
    },
    {
        path: ':id/section',
        component: AsapNewsSectionComponent
    },
    {
        path: 'view/all',
        component: AllNewsComponent
    },
];

/**
 * @fileoverview added by tsickle
 * Generated from: public-api.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * Generated from: asap-news.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { AsapNewsComponent, AsapNewsModule, AsapNewsRouting, AsapNewsService, AllNewsComponent as ɵa, AsapNewsDetailComponent as ɵb, AsapNewsSectionComponent as ɵc, SafePipe as ɵd };
//# sourceMappingURL=asap-news.js.map
