import { HttpHeaders, HttpClient } from '@angular/common/http';
import { Injectable, ɵɵdefineInjectable, ɵɵinject, Component, Pipe, NgModule } from '@angular/core';
import { __extends, __assign, __spread } from 'tslib';
import { Location, CommonModule } from '@angular/common';
import { ActivatedRoute, RouterModule } from '@angular/router';
import { AsapSharedModule } from 'asap-shared';
import { AsapService, Global, AsapBaseCRUD } from 'asap-crud';
import { DomSanitizer } from '@angular/platform-browser';

/**
 * @fileoverview added by tsickle
 * Generated from: lib/asap-news.service.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var AsapNewsService = /** @class */ (function () {
    function AsapNewsService(http) {
        this.http = http;
        this.host = localStorage.getItem('apiURL');
    }
    /**
     * @param {?} id
     * @return {?}
     */
    AsapNewsService.prototype.find = /**
     * @param {?} id
     * @return {?}
     */
    function (id) {
        return this.http.get(this.host + '/api/v2/client/news/' + id, this.getHeaders());
    };
    /**
     * @param {?} id
     * @return {?}
     */
    AsapNewsService.prototype.section = /**
     * @param {?} id
     * @return {?}
     */
    function (id) {
        return this.http.get(this.host + '/api/v2/client/news-section/' + id + '/news', this.getHeaders());
    };
    /**
     * @return {?}
     */
    AsapNewsService.prototype.getHeaders = /**
     * @return {?}
     */
    function () {
        /** @type {?} */
        var token = '';
        if (localStorage.getItem('token')) {
            token = localStorage.getItem('token');
        }
        /** @type {?} */
        var headerOptions = {
            'Authorization': token,
            'Accept': 'application/json'
        };
        return { headers: new HttpHeaders(headerOptions) };
    };
    AsapNewsService.decorators = [
        { type: Injectable, args: [{
                    providedIn: 'root'
                },] }
    ];
    /** @nocollapse */
    AsapNewsService.ctorParameters = function () { return [
        { type: HttpClient }
    ]; };
    /** @nocollapse */ AsapNewsService.ngInjectableDef = ɵɵdefineInjectable({ factory: function AsapNewsService_Factory() { return new AsapNewsService(ɵɵinject(HttpClient)); }, token: AsapNewsService, providedIn: "root" });
    return AsapNewsService;
}());
if (false) {
    /** @type {?} */
    AsapNewsService.prototype.host;
    /** @type {?} */
    AsapNewsService.prototype.http;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/asap-news.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var AsapNewsComponent = /** @class */ (function () {
    function AsapNewsComponent() {
    }
    AsapNewsComponent.decorators = [
        { type: Component, args: [{
                    selector: 'asap-news',
                    template: "<router-outlet></router-outlet>"
                }] }
    ];
    return AsapNewsComponent;
}());

/**
 * @fileoverview added by tsickle
 * Generated from: lib/all-news/all-news.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var AllNewsComponent = /** @class */ (function (_super) {
    __extends(AllNewsComponent, _super);
    function AllNewsComponent(global, activatedRoute, service) {
        var _this = _super.call(this, global, service) || this;
        _this.global = global;
        _this.activatedRoute = activatedRoute;
        _this.service = service;
        _this.service.basePath = 'api/v2/client';
        _this.service.entityName = 'news/search';
        _this.cumulativeData = true;
        /** @type {?} */
        var params = _this.global.decodeQueryString();
        _this.session = params.session;
        _this.title = params.session_name;
        _this.afterCreate();
        return _this;
    }
    /**
     * @return {?}
     */
    AllNewsComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
    };
    /**
     * @param {?=} page
     * @return {?}
     */
    AllNewsComponent.prototype.listAll = /**
     * @param {?=} page
     * @return {?}
     */
    function (page) {
        var _this = this;
        if (page === void 0) { page = 1; }
        /** @type {?} */
        var data = __assign({ session: this.session }, this.filter);
        this.service.createResource(data).subscribe((/**
         * @param {?} response
         * @return {?}
         */
        function (response) {
            _this.list = response;
        }));
    };
    /**
     * @param {?} filter
     * @return {?}
     */
    AllNewsComponent.prototype.doFilter = /**
     * @param {?} filter
     * @return {?}
     */
    function (filter) {
        this.filter = filter;
        this.listAll();
    };
    AllNewsComponent.decorators = [
        { type: Component, args: [{
                    selector: 'app-all-news',
                    template: "<div class=\"wrapper\">\n  <!-- <app-navbar></app-navbar>\n  <app-navbar-mobile></app-navbar-mobile>\n  <app-sidemenu></app-sidemenu> -->\n  <div class=\"content\">\n    <div class=\"compress py-5\">\n      <!-- <h3>{{title}}</h3> -->\n      <asap-generic-all (filter)=\"doFilter($event)\" [data]=\"list\" *ngIf=\"list\"></asap-generic-all>\n\n      <div class=\"text-center\" *ngIf=\"meta?.current_page != meta?.last_page\">\n        <button *ngIf=\"!loading\" class=\"btn btn-primary\" (click)=\"listAll(meta?.current_page+1)\">Carregar mais</button>\n        <button *ngIf=\"loading\" class=\"btn btn-primary\" disabled>\n          <i class=\"fa fa-spin fa-circle-o-notch\"></i>\n        </button>\n      </div>\n    </div>\n  </div>\n</div>\n",
                    providers: [AsapService]
                }] }
    ];
    /** @nocollapse */
    AllNewsComponent.ctorParameters = function () { return [
        { type: Global },
        { type: ActivatedRoute },
        { type: AsapService }
    ]; };
    return AllNewsComponent;
}(AsapBaseCRUD));
if (false) {
    /** @type {?} */
    AllNewsComponent.prototype.session;
    /** @type {?} */
    AllNewsComponent.prototype.title;
    /** @type {?} */
    AllNewsComponent.prototype.filter;
    /** @type {?} */
    AllNewsComponent.prototype.global;
    /** @type {?} */
    AllNewsComponent.prototype.activatedRoute;
    /** @type {?} */
    AllNewsComponent.prototype.service;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/detail/asap-news-detail.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var AsapNewsDetailComponent = /** @class */ (function () {
    function AsapNewsDetailComponent(newsService, activatedRoute, location) {
        var _this = this;
        this.newsService = newsService;
        this.activatedRoute = activatedRoute;
        this.location = location;
        this.activatedRoute.params.subscribe((/**
         * @param {?} param
         * @return {?}
         */
        function (param) {
            _this.id = +param.id;
        }));
    }
    /**
     * @return {?}
     */
    AsapNewsDetailComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        /** @type {?} */
        var lu = localStorage.getItem('loggedUser');
        if (lu) {
            this.loggedUser = JSON.parse(lu).data;
        }
        this.getData();
    };
    /**
     * @return {?}
     */
    AsapNewsDetailComponent.prototype.getData = /**
     * @return {?}
     */
    function () {
        var _this = this;
        this.loading = true;
        this.newsService.find(this.id)
            .subscribe((/**
         * @param {?} res
         * @return {?}
         */
        function (res) {
            if (_this.loggedUser || res.data.visibility === 'guest') {
                _this.item = res.data;
            }
            else {
                _this.notFound = true;
            }
            _this.loading = false;
        }));
    };
    AsapNewsDetailComponent.decorators = [
        { type: Component, args: [{
                    selector: 'asap-news-detail',
                    template: "<p *ngIf=\"loading\">Carregando...</p>\n<div style=\"margin-top: 20px\" class=\"col-sm-12 text-right\">\n  <a (click)=\"location.back()\">\n    <i class=\"bi bi-x-circle\" style=\"font-size: 30px\"></i>\n  </a>\n</div>\n<div class=\"row\" *ngIf=\"!loading\">\n  <div class=\"col-sm-8 mx-auto\">\n    <div class=\"intro-post\">\n      <h1>{{ item.title }}</h1>\n      <h4 class=\"mt-2\">{{ item.resume }}</h4>\n      <span class=\"date-post\"\n        ><i class=\"fa fa-clock\"></i> {{ item.created_at | date : \"dd/MM/y\" }} \u00E0s\n        {{ item.created_at | date : \"hh:mm\" }}</span\n      >\n    </div>\n\n    <img [src]=\"item.image\" class=\"cover-post\" alt=\"\" />\n\n    <div>\n      <div\n        class=\"asap-news-detail-text\"\n        [innerHTML]=\"item.text | safe : 'html'\"\n      ></div>\n    </div>\n\n    <div class=\"row\" *ngIf=\"item.author\">\n      <div class=\"col-sm-12\">\n        <div class=\"divider-line\"></div>\n        <figure>\n          <img [src]=\"item.author_photo\" class=\"user-created\" />\n        </figure>\n        <div class=\"user-created-info\">\n          <h2 class=\"written-by\">\n            Escrito por <strong>{{ item.author }}</strong>\n          </h2>\n          <span class=\"autor-description\">{{ item.author_about }}</span>\n        </div>\n      </div>\n    </div>\n\n    <div\n      *ngIf=\"item.attachments && item.attachments.length\"\n      class=\"download-area\"\n    >\n      <p class=\"title\">Anexos:</p>\n      <p class=\"mb-3\">Clique no(s) arquivo(s) para baixar.</p>\n      <div class=\"row\">\n        <div *ngFor=\"let att of item.attachments\" class=\"col-sm-4\">\n          <a target=\"_blank\" [href]=\"att.path\">\n            <i aria-hidden=\"true\" class=\"fa fa-file-pdf-o\"></i>\n            <span class=\"ml-2\">{{ att.name }}</span>\n          </a>\n        </div>\n      </div>\n    </div>\n  </div>\n</div>\n\n<p *ngIf=\"notFound\">Not\u00EDcia n\u00E3o dispon\u00EDvel</p>\n",
                    styles: [".intro-post{display:flex;flex-direction:column;align-items:center;justify-content:space-around;min-height:100px;margin-bottom:30px;padding-top:30px;height:auto;text-align:center}.download-area{background:#f4f4f4;padding:10px;border-radius:4px;margin:20px 0}.download-area p.title{font-weight:500}.download-area a{display:block;min-width:100%;max-width:15ch;overflow:hidden;text-overflow:ellipsis;white-space:nowrap;color:#fff;background:var(--main-color);margin-bottom:10px;padding:5px 10px;font-size:13px;border-radius:4px}.download-area a:hover{opacity:.7}.date-post{padding-top:20px;text-transform:uppercase;color:#888;font-size:15px;font-weight:700}.cover-post{width:100%;height:auto;border-radius:16px;-o-object-fit:cover;object-fit:cover;margin-bottom:30px}.divider-line{width:100%;height:1px;margin-bottom:48px;margin-top:48px;background-color:#e1e1e1}figure{margin:0 0 1rem}figure .user-created{float:left;width:160px;height:160px;margin-right:20px;-o-object-fit:cover;object-fit:cover;border-radius:50%;overflow:hidden;padding:4px;border:1px solid #e1e1e1;display:block}.user-created-info{display:flex;align-items:flex-start;justify-content:center;flex-direction:column;height:160px;width:calc(100% - 180px);margin-bottom:50px}.user-created-info .written-by{padding-bottom:10px;font-weight:300}.user-created-info .autor-description{line-height:22px}@media (max-width:575.98px){figure{margin:0}figure .user-created{float:none;width:100px;height:100px;margin:0 auto 40px;-o-object-fit:cover;object-fit:cover;border-radius:50%;overflow:hidden}.user-created-info{display:flex;align-items:center;justify-content:center;flex-direction:column;height:auto;width:100%;margin-bottom:50px;text-align:center}.user-created-info .written-by{padding-bottom:10px;font-weight:300;font-size:18px}.user-created-info .autor-description{line-height:22px}}"]
                }] }
    ];
    /** @nocollapse */
    AsapNewsDetailComponent.ctorParameters = function () { return [
        { type: AsapNewsService },
        { type: ActivatedRoute },
        { type: Location }
    ]; };
    return AsapNewsDetailComponent;
}());
if (false) {
    /** @type {?} */
    AsapNewsDetailComponent.prototype.id;
    /** @type {?} */
    AsapNewsDetailComponent.prototype.loading;
    /** @type {?} */
    AsapNewsDetailComponent.prototype.item;
    /** @type {?} */
    AsapNewsDetailComponent.prototype.loggedUser;
    /** @type {?} */
    AsapNewsDetailComponent.prototype.notFound;
    /** @type {?} */
    AsapNewsDetailComponent.prototype.newsService;
    /** @type {?} */
    AsapNewsDetailComponent.prototype.activatedRoute;
    /** @type {?} */
    AsapNewsDetailComponent.prototype.location;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/safe.pipe.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var SafePipe = /** @class */ (function () {
    function SafePipe(sanitizer) {
        this.sanitizer = sanitizer;
    }
    /**
     * @param {?} url
     * @param {?=} type
     * @return {?}
     */
    SafePipe.prototype.transform = /**
     * @param {?} url
     * @param {?=} type
     * @return {?}
     */
    function (url, type) {
        switch (type) {
            case 'html': return this.sanitizer.bypassSecurityTrustHtml(url);
            case 'style': return this.sanitizer.bypassSecurityTrustStyle(url);
            case 'script': return this.sanitizer.bypassSecurityTrustScript(url);
            case 'url': return this.sanitizer.bypassSecurityTrustUrl(url);
            case 'resourceUrl': return this.sanitizer.bypassSecurityTrustResourceUrl(url);
            default: return this.sanitizer.bypassSecurityTrustResourceUrl(url);
        }
    };
    SafePipe.decorators = [
        { type: Pipe, args: [{ name: 'safe' },] }
    ];
    /** @nocollapse */
    SafePipe.ctorParameters = function () { return [
        { type: DomSanitizer }
    ]; };
    return SafePipe;
}());
if (false) {
    /**
     * @type {?}
     * @private
     */
    SafePipe.prototype.sanitizer;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/section/asap-news-section.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var AsapNewsSectionComponent = /** @class */ (function () {
    function AsapNewsSectionComponent(newsService, activatedRoute) {
        var _this = this;
        this.newsService = newsService;
        this.activatedRoute = activatedRoute;
        this.activatedRoute.params.subscribe((/**
         * @param {?} param
         * @return {?}
         */
        function (param) {
            _this.id = +param.id;
        }));
    }
    /**
     * @return {?}
     */
    AsapNewsSectionComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        this.getData();
    };
    /**
     * @return {?}
     */
    AsapNewsSectionComponent.prototype.getData = /**
     * @return {?}
     */
    function () {
        var _this = this;
        this.loading = true;
        this.newsService.section(this.id)
            .subscribe((/**
         * @param {?} res
         * @return {?}
         */
        function (res) {
            _this.data = res.data;
            _this.loading = false;
        }));
    };
    AsapNewsSectionComponent.decorators = [
        { type: Component, args: [{
                    selector: 'asap-news-section',
                    template: "<pre>{{ data | json }}</pre>"
                }] }
    ];
    /** @nocollapse */
    AsapNewsSectionComponent.ctorParameters = function () { return [
        { type: AsapNewsService },
        { type: ActivatedRoute }
    ]; };
    return AsapNewsSectionComponent;
}());
if (false) {
    /** @type {?} */
    AsapNewsSectionComponent.prototype.id;
    /** @type {?} */
    AsapNewsSectionComponent.prototype.loading;
    /** @type {?} */
    AsapNewsSectionComponent.prototype.data;
    /** @type {?} */
    AsapNewsSectionComponent.prototype.newsService;
    /** @type {?} */
    AsapNewsSectionComponent.prototype.activatedRoute;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/asap-news.module.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
var components = [
    AllNewsComponent,
    AsapNewsComponent,
    AsapNewsDetailComponent,
    AsapNewsSectionComponent
];
var AsapNewsModule = /** @class */ (function () {
    function AsapNewsModule() {
    }
    AsapNewsModule.decorators = [
        { type: NgModule, args: [{
                    imports: [
                        CommonModule,
                        RouterModule,
                        AsapSharedModule
                    ],
                    declarations: __spread(components, [
                        SafePipe
                    ]),
                    exports: __spread(components)
                },] }
    ];
    return AsapNewsModule;
}());

/**
 * @fileoverview added by tsickle
 * Generated from: lib/asap-news.routing.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
var AsapNewsRouting = [
    {
        path: ':id',
        component: AsapNewsDetailComponent
    },
    {
        path: ':id/section',
        component: AsapNewsSectionComponent
    },
    {
        path: 'view/all',
        component: AllNewsComponent
    },
];

/**
 * @fileoverview added by tsickle
 * Generated from: public-api.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * Generated from: asap-news.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { AsapNewsComponent, AsapNewsModule, AsapNewsRouting, AsapNewsService, AllNewsComponent as ɵa, AsapNewsDetailComponent as ɵb, AsapNewsSectionComponent as ɵc, SafePipe as ɵd };
//# sourceMappingURL=asap-news.js.map
